/*
 * Mmap.h -- Declaration of the Mmap struct.  Based on a utility that I
 *           dreamed up in late '98 / early '99.
 *
 * devphil@users.sourceforge.net
 * $Id: Mmap.h,v 1.1 2000/03/06 17:51:19 pedwards Exp $
*/


#ifndef CMS_MMAP_H
#define CMS_MMAP_H

/* This added for LL. */
#define HAVE_MMAP

#ifndef HAVE_MMAP
#error mmap(2) apparently not available -- no point to Mmap.h!
#endif

#define _XOPEN_SOURCE 500
#include <sys/types.h>
#include <sys/mman.h>
#include <string>

#ifndef MAP_FILE
#define MAP_FILE 0
#endif


struct Mmap
{
    static std::string errortext;
    static bool        nothrow;

    void*  srcp;
    off_t  sz;

    Mmap (std::string const& filename,
          int prot = PROT_READ | PROT_WRITE,
          int flags = MAP_FILE | MAP_SHARED);
    ~Mmap();

    std::string str() const;
};

#endif /* CMS_MMAP_H */


