/* 
 * LatestLog 1.2.2
 * opts.cc -- Definitions to perform command-line option processing.
 *
 * GENERATED BY GENOPT -- CHANGES WILL BE LOST
*/

#include <stdlib.h>    // eventually <cstdlib>
#include "opts.h"
#include <string>
#include <iostream>
#include <libgen.h>    // or whatever contains basename(3)

// _XOPEN_SOURCE kills these three decls... icky
extern "C" {
extern int optind, opterr, optopt;
extern char *optarg;
extern int getopt(int, char *const *, const char *);
}

using std::string;

namespace {
    // name of program; this is guessed and may need to be changed by you
    string  argvzero;

    void print_usage();
    void print_help();
    void print_version();
}  // end unnamed namespace


std::string  genopt_dbase_option; // = "SINCE_DB env";
bool         genopt_dbase_option_given = false;

bool         genopt_reinit_option = false;

bool         genopt_reinitnow_option = false;

bool         genopt_readonly_option = false;

bool         genopt_check_option = false;

bool         genopt_cat_option = false;

bool         genopt_page_option = true;


int genopt_process_options (int argc, char** argv)
{
    argvzero = basename(argv[0]);  // possibly a Bad Thing to do
    opterr = 0;

    int c;
    while ((c = getopt(argc, argv, "hvf:iIrzcp")) != EOF) {
        switch (c) {
            case 'f':
                genopt_dbase_option_given = true;
                genopt_dbase_option = optarg;
                break;
            case 'i':
                genopt_reinit_option = !genopt_reinit_option;
                break;
            case 'I':
                genopt_reinitnow_option = !genopt_reinitnow_option;
                break;
            case 'r':
                genopt_readonly_option = !genopt_readonly_option;
                break;
            case 'z':
                genopt_check_option = !genopt_check_option;
                break;
            case 'c':
                genopt_cat_option = !genopt_cat_option;
                genopt_page_option = !genopt_page_option;
                break;
            case 'p':
                genopt_page_option = !genopt_page_option;
                genopt_cat_option = !genopt_cat_option;
                break;
            case '?':
                std::cerr << argvzero << ":  Unrecognized or missing option \'"
                          << static_cast<char>(optopt) << "\'\n";
                print_usage();
                ::exit(1);
                break; /* NOTREACHED */
            case 'h':
                print_help();
                ::exit(0);
                break; /* NOTREACHED */
            case 'v':
                print_version();
                ::exit(0);
                break; /* NOTREACHED */
        }
    }
    // test for remaining_args_required
    if (argc - optind < 1) {
        std::cerr << argvzero << ":  Required argument missing\n";
        print_usage();
        ::exit(1);
    }
    return optind;
}

namespace {   // Indentation violated inside this namespace block

void print_usage()
{
    using std::cerr;
    cerr << "Usage:  " << argvzero
         << " [-hv] "     // assuming you want help/version, else delete/comment
    "[-f database] [-i|-I] [-r] [-z] [-c|-p] logfile..."
         << std::endl;
}


void print_help()
{
    using std::cout;

    print_version();
    print_usage();
    // Lines with [default] can be removed entirely if you like
    cout << "Options:\n" <<
"  -f database                 Path to the database [default \"SINCE_DB env\"]\n"
"  -i                          [Re-]initialize entries for listed files to\n"
"                              zero and exit\n"
"  -I                          [Re-]initialize entries for listed files to\n"
"                              current time and exit\n"
"  -r                          Do not update the database\n"
"  -z                          Only compare times, exit with funky values\n"
"  -c                          Just 'cat' the output all together\n"
"  -p                          Use PAGER on temporary files [default]\n"
         << std::endl;
}


void print_version()
{
    std::cout << "LatestLog version 1.2.2" << std::endl;
    //std::cout << "v1.2.2" << std::endl;
}

}  // end unnamed namespace


