/*
 * sincedecls.h -- Declarations of functions and variables.  Not much
 *                 else to say, is there?
 *
 * $Id: sincedecls.h,v 1.4 2000/04/28 23:53:21 pedwards Exp $
*/

#ifndef SINCEDECLS_H
#define SINCEDECLS_H

#define _XOPEN_SOURCE 500

#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ndbm.h>
#include <iosfwd>
#include <fcntl.h>
#include <string>

using std::string;

extern string    dbname;
extern DBM*      db;
extern time_t    rightnow;
extern string    pagername;

extern void   reset_logfile (const string&, time_t);
extern int    check_for_new (const string&);
extern void   append_new (const string&, std::ofstream&);

extern bool   has_changed (const string&);
extern time_t getmtime (const string&);
extern size_t getsize (const string&);

struct fatal_error_struct
{
    static std::ostream* es;
    static std::string   st;

    explicit fatal_error_struct (const char*);
    ~fatal_error_struct();
    operator std::ostream& ();
};
extern fatal_error_struct  fatal_error (const char*);

#endif /* SINCEDECLS_H */

