/*
 * stats.cc -- Takes care of stat(2)'ing any files and answering predicates
 *             such as "does this file have new stuff?" -- since how that's
 *             answered may change.
 *
 * $Id: stats.cc,v 1.2 2000/03/05 03:47:43 pedwards Exp $
*/

#include <sincedecls.h>
#include <sys/types.h>
#include <sys/stat.h>


bool has_changed (const string& f)
{
    return getmtime(f) < rightnow;
}


time_t getmtime (const string& f)
{
    struct stat buf;
    if (stat(f.c_str(),&buf) != 0)
        fatal_error("getm couldn't stat ") << f << ":  " << strerror(errno);
    return buf.st_mtime;
}


size_t getsize (const string& f)
{
    struct stat buf;
    if (stat(f.c_str(),&buf) != 0)
        fatal_error("gets couldn't stat ") << f << ":  " << strerror(errno);
    return buf.st_size;
}


